diff -Nur doc-central-1.8.2+nmu1/cgi/contents.cgi doc-central-1.8.2+nmu2/cgi/contents.cgi
--- doc-central-1.8.2+nmu1/cgi/contents.cgi	2008-04-27 14:27:22.000000000 +0200
+++ doc-central-1.8.2+nmu2/cgi/contents.cgi	2008-11-10 18:49:19.000000000 +0100
@@ -12,7 +12,7 @@
 	hdr=0
 
 	if len(sect):
-		matcher=re.compile(sect+"/", re.IGNORECASE)
+		matcher=re.compile(re.escape(sect+"/"), re.IGNORECASE)
 	else:
 		matcher=re.compile("")
 
diff -Nur doc-central-1.8.2+nmu1/cgi/docutils.py doc-central-1.8.2+nmu2/cgi/docutils.py
--- doc-central-1.8.2+nmu1/cgi/docutils.py	2008-04-27 14:36:12.000000000 +0200
+++ doc-central-1.8.2+nmu2/cgi/docutils.py	2008-11-10 19:13:04.000000000 +0100
@@ -3,7 +3,7 @@
 # throughout Doc-Central.
 
 # Import all system packages we need
-import os, string, sys, cgi, re
+import os, string, sys, cgi, re, urllib
 # Import all our own packages
 import docinfo, docconfig
 
@@ -78,12 +78,13 @@
 def makesectionlink(sect):
 	'''Create a URL to the section-index. We assume that the current
 	script is already the browser'''
+	# Note: the function is never called since it's overriden at the bottom
 
 	if os.environ.has_key("SCRIPT_NAME"):
 		base=os.environ["SCRIPT_NAME"]
 	else:
 		base="browse.cgi"
-	return base+"?section="+sect
+	return base+"?section="+urllib.quote(sect)
 
 
 def makedoclink(doc, format=None):
@@ -184,4 +185,4 @@
 	'''Turn a section-name into an URL to the right section-page using
 	browse.cgi'''
 
-	return scriptname("browse.cgi") + "?section=%s" % sect
+	return scriptname("browse.cgi") + "?section=%s" % urllib.quote(sect)
diff -Nur doc-central-1.8.2+nmu1/debian/changelog doc-central-1.8.2+nmu2/debian/changelog
--- doc-central-1.8.2+nmu1/debian/changelog	2008-04-27 14:47:04.000000000 +0200
+++ doc-central-1.8.2+nmu2/debian/changelog	2008-11-11 10:43:06.000000000 +0100
@@ -1,3 +1,12 @@
+doc-central (1.8.2+nmu2) unstable; urgency=medium
+
+  * Non-maintainer upload to fix bugs related to processing of the
+    Programming/C++ doc-base section (closes: #502556):
+    - browse.cgi: handle section names that contain regex metacharacters;
+    - docutils.py: properly encode URLs generated by makesectionlink().
+
+ -- Robert Luberda <robert@debian.org>  Tue, 11 Nov 2008 10:43:04 +0100
+
 doc-central (1.8.2+nmu1) unstable; urgency=low
 
   * Non-maintainer upload.
